;(function () {
'use strict'

const inputWhitelist = ["text","number","password","search","email","tel","url"]

// Maintain a whitelisted toggle in sync from background script since checking
// `window.top.location.hostname` fails for cross-domain iframes:
let whitelisted = false
browser.runtime.onMessage.addListener(w =>
    // Though I haven't found documentation to this effect, empirically, it seems that messages
    // don't cross to other addons, so no need to filter.
    whitelisted = w)

function saveKeys(keyEvent) {
    const _ = keyEvent.target

    const allow = whitelisted
    || keyEvent.key === 'Escape'
    || _.isContentEditable
    || document.fullscreen || document.mozFullScreen
    || document.pointerLockElement || document.mozPointerLockElement
    || (_ instanceof HTMLInputElement && inputWhitelist.includes(_.type))
    || (_ instanceof HTMLMediaElement && !_.controls)
    || (_ instanceof HTMLTextAreaElement)

    allow || keyEvent.stopImmediatePropagation()
}

window.addEventListener('keydown', saveKeys, true)
window.addEventListener('keypress', saveKeys, true)
window.addEventListener('keyup', saveKeys, true)

})()
